#
# Note: /xb should be a symbolic link to the source (= current) directory.
# An empty XB doesn't work yet.
#
XB		= .
#XBLIB		= $(XB)/lib
XBLIB		= lib
COMPILER	= xcol
APP		= xb
MAIN		= $(XBLIB)/xstart.o
OO		= $(XBLIB)/xlib.o xit.o $(XB)/xin.o $(XB)/$(COMPILER).o\
		  $(XB)/xdis.o $(XB)/xcm.o $(XB)/xma.o $(XB)/xst.o\
		  $(XB)/xgr.o $(XB)/xui.o $(XB)/kernel32.o $(XB)/gdi32.o\
		  $(XB)/user32.o $(XBLIB)/xzzz.o xbiface.o
CFLAGS		= -g -Wall -ggdb

all:	$(APP) $(XBLIB)/appstart.o

$(APP):	$(MAIN) $(OO) 
	$(CC) $(CFLAGS) $(MAIN) $(OO) -rdynamic -L/usr/X11R6/lib -lX11 -lm -ldl -o $(APP)
	nm -g $(APP) > xlabs

clean:
	-rm *.o
	-rm xb
	-rm lib/*.o
	-rm *.def
#	-rm *.dec
#	-rm *.s
	-rm *~
	-rm xlabs
	-rm -rf rel

%.o: %.c
	$(CC) -c $<

%.o: %.s
	gcc -c -g -ggdb $< -o $@

%.s: %.x
	xb $< -lib

install-dec:
	cp dec/clib.dec /usr/xb
	cp dec/clib.dec $(HOME)/xb

release:
	rm -rf rel
	mkdir rel
	(cd rel; unzip /tmp/xblinux.zip)
	rm -f rel/usr/bin/xb
	cp xb rel/usr/bin
	cp *.o rel/usr/xb
	cp lib/*.o rel/usr/xb/lib
	cp dec/clib.dec rel/usr/xb
	(cd rel; tar cfz xblinux.tar.gz *)
